package main

import (
	"sparrow/pkg/rpcs"
	"sparrow/pkg/server"
)

func main() {
	// init server
	err := server.Init(rpcs.ControllerName)
	if err != nil {
		server.Log.Fatal(err)
		return
	}
	// register a rpc service
	controller, err := NewController(*confRabbitHost)
	if err != nil {
		server.Log.Errorf("NewController Error: %s", err)
		return
	}
	_, err =controller.initActorSystem()
	if err != nil {
		server.Log.Errorf("NewController Error: %s", err)
		return
	}
	go controller.launchConsumer()

	err = server.RegisterRPCHandler(controller)
	if err != nil {
		server.Log.Errorf("Register RPC service Error: %s", err)
		return
	}

	// start to run
	err = server.Run()
	if err != nil {
		server.Log.Fatal(err)
	}
}
